Wt: Wt::WTable Class Reference

Wt 3.3.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Hierarchy
- Class Members

Public Member Functions
Wt::WTable Class Reference

A container widget which provides layout of children in a table grid. More...

`#include <Wt/WTable>`

Inheritance diagram for Wt::WTable:
[legend]

List of all members.

## Public Member Functions
| WTable (WContainerWidget *parent=0)
| Creates an empty table.
| ~WTable ()
| Deletes the table and its entire contents.
WTableCell * | elementAt (int row, int column)
| Accesses the table element at the given row and column.
WTableRow * | rowAt (int row)
| Returns the row object for the given row.
WTableColumn * | columnAt (int column)
| Returns the column object for the given column.
void | removeCell (WTableCell *item)
| Deletes a table cell and its contents.
void | removeCell (int row, int column)
| Deletes the table cell at the given position.
WTableRow * | insertRow (int row)
| Inserts an empty row.
void | deleteRow (int row)
| Deletes a row and all its contents.
WTableColumn * | insertColumn (int column)
| Inserts an empty column.
void | deleteColumn (int column)
| Delete a column and all its contents.
void | clear ()
| Clears the entire table.
int | rowCount () const
| Returns the number of rows in the table.
int | columnCount () const
| Returns the number of columns in the table.
void | setHeaderCount (int count, Orientation orientation=Horizontal)
| Sets the number of header rows or columns.
int | headerCount (Orientation orientation=Horizontal)
| Returns the number of header rows or columns.
void | moveRow (int from, int to)
| Move a table row from its original position to a new position.
void | moveColumn (int from, int to)
| Move a table column from its original position to a new position.

## Detailed Description

A container widget which provides layout of children in a table grid.

A WTable arranges its children in a table.

To insert or access contents, use elementAt(int row, int column) to access the cell at a particular location in the table. The WTable expands automatically to create the indexed (row, column) as necessary.

It is possible to insert and delete entire rows or columns from the table using the insertColumn(int column), insertRow(int row), deleteColumn(int column), or deleteRow(int row) methods.

You may indicate a number of rows and columns that act as headers using setHeaderCount(). Header cells are rendered as `<th>` instead of `<td>` elements. By default, no rows or columns are configured as headers.

WTable is displayed as a block.

Usage example:

     Wt::WTable *table = new Wt::WTable(this);
     table->elementAt(0, 0)->addWidget(new Wt::WText("Item @ row 0, column 0"));
     table->elementAt(0, 1)->addWidget(new Wt::WText("Item @ row 0, column 1"));
     table->elementAt(1, 0)->addWidget(new Wt::WText("Item @ row 1, column 0"));
     table->elementAt(1, 1)->addWidget(new Wt::WText("Item @ row 1, column 1"));

     Wt::WTableCell *cell = table->elementAt(2, 0);
     cell->addWidget(new Wt::WText("Item @ row 2"));
     cell->setColumnSpan(2);

### CSS

The widget corresponds to the HTML `<table>` tag and does not provide styling. It can be styled using inline or external CSS as appropriate.

See also:
  WTableCell, WTableRow, WTableColumn

## Member Function Documentation

void Wt::WTable::clear | ( |  | ) |

Clears the entire table.

This method clears the entire table: all cells and their contents are deleted.

WTableColumn * Wt::WTable::columnAt | ( | int | column | ) |

Returns the column object for the given column.

Like with elementAt(), the table expands automatically when the column is beyond the current table dimensions.

See also:
  elementAt(int, int), rowAt(int)

void Wt::WTable::deleteRow | ( | int | row | ) |

Deletes a row and all its contents.

Rows below the given row are shifted up.

WTableCell * Wt::WTable::elementAt | ( | int | row,
|  | int | column
| ) |  |

Accesses the table element at the given row and column.

If the row/column is beyond the current table dimensions, then the table is expanded automatically.

int Wt::WTable::headerCount | ( | Orientation | orientation = `Horizontal` | ) |

Returns the number of header rows or columns.

See also:
  setHeaderCount()

void Wt::WTable::moveColumn | ( | int | from,
|  | int | to
| ) |  |

Move a table column from its original position to a new position.

The table expands automatically when the `to` column is beyond the current table dimensions.

See also:
  moveRow()

void Wt::WTable::moveRow | ( | int | from,
|  | int | to
| ) |  |

Move a table row from its original position to a new position.

The table expands automatically when the `to` row is beyond the current table dimensions.

See also:
  moveColumn()

void Wt::WTable::removeCell | ( | WTableCell * | item | ) |

Deletes a table cell and its contents.

The table cell at that position is recreated.

void Wt::WTable::removeCell | ( | int | row,
|  | int | column
| ) |  |

Deletes the table cell at the given position.

See also:
  removeCell(WTableCell *)

WTableRow * Wt::WTable::rowAt | ( | int | row | ) |

Returns the row object for the given row.

Like with elementAt(), the table expands automatically when the row is beyond the current table dimensions.

See also:
  elementAt(int, int), columnAt(int)

void Wt::WTable::setHeaderCount | ( | int | count,
|  | Orientation | orientation = `Horizontal`
| ) |  |

Sets the number of header rows or columns.

The default values are 0.

Note:
  This must be set before the initial rendering and cannot be changed later.

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator